<?php
/**
 * @ H2N Link Directory 1.0.0 linkdirectory.comments.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 linkdirectory.comments.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

function comment_allow($row){
	global $database, $my, $ld, $Itemid;
	# User IP Address
	$vote_ip = getenv( 'REMOTE_ADDR' );

	# Check if this user has voted before
	if ( $my->id == 0 ) {
		$database->setQuery( "SELECT log_date FROM #__ldlog WHERE link_id ='".$row->id."' AND log_ip = '".$vote_ip."' AND log_type = 'comment'" );
	} else {
		$database->setQuery( "SELECT log_date FROM #__ldlog WHERE link_id ='".$row->id."' AND user_id = '".$my->id."' AND log_type = 'comment'" );
	}
	$soner = $database->loadResult();

	$comment = false;
	$comment = ($soner <> '') ? true : false;

	if ( $comment && $ld->writeonce == '1') {
		# This user has already comment this link
		mosRedirect(getItemURL('detail',$row->id,$Itemid), _LD_ONLY_ONE_COMMENT );
		return false;
	} elseif ( $ld->gaddcom == '0' && $my->id < 1 ) {
		#user login
		mosRedirect(getItemURL('detail',$row->id,$Itemid), _LD_COM_ONLY_AFTER_LOGIN );
		return false;
	}
	return true;
}

function sendEmail($id,$your_name, $report_type, $message,$Itemid){
	global $ld,$database,$mosConfig_sitename;
	
	$text = sprintf(_LD_REPORT_MSG, 
	  sefRelToAbs("index.php?option=com_linkdirectory&task=detail&id=$id&Itemid=$Itemid"),$your_name, $report_type, $message);
	$text = html_entity_decode($text,ENT_NOQUOTES);
	$subject = _LD_REPORT_SUBJECT." - ".$mosConfig_sitename;
	
	if ($ld->reportemail) {
		// Gid from Super Administrators and Administrators 
		$gid = 25;
		$gid2 = 24;

		// list of admins
		$query = "SELECT email, name"
		. "\n FROM #__users"
		. "\n WHERE ( gid = $gid"
		. "\n OR gid = $gid2 )"
		. "\n AND sendEmail = 1"
		;
		$database->setQuery( $query );
		if(!$database->query()) {
			echo $database->stderr( true );
			return;
		}
		$adminRows = $database->loadObjectList();

		// send email notification to admins
		foreach($adminRows as $adminRow) {
			mosMail( $adminRow->email, $your_name, $adminRow->email, $subject,wordwrap($text));
		}
	}

	if ($ld->semail) {
		mosMail( $ld->semail, $your_name, $adminRow->email, $subject, wordwrap($text));
	}
}

function insertNewComment($id, $my_id, $guest_name, $report_type, $rev_title, $rev_text, $rev_approved){
	global $database,$mosConfig_offset;

	$now = date( "Y-m-d H:i:s", time()+$mosConfig_offset*60*60 );
	if ( $my_id > 0 ) {
		# User is logged on, store user ID
		$database->setQuery( "INSERT INTO #__ldcomment"
		.	"( `link_id` , `user_id`, `type`, `rev_title` , `rev_text` , `rev_date` , `rev_approved` ) "
		.	"VALUES ($id, $my_id, '$report_type', '$rev_title', '$rev_text', '$now', '$rev_approved')");
	} else {
		# User is not logged on, store Guest name
		$database->setQuery( "INSERT INTO #__ldcomment"
		.	"( `link_id` , `guest_name` , `type`, `rev_title` , `rev_text` , `rev_date` , `rev_approved` ) "
		.	"VALUES ($id, '$guest_name', '$report_type',  '$rev_title', '$rev_text', '$now', '$rev_approved')");
	}
	return $database->query();
}


/**
 * Show comment page if settings are enabled
 *
 * @param int $id Id des Links, der kommentiert werden soll
 * @param String $option unbenutzt
 * @param boolean $badLinkReport true, wenn Kommentar ein BadLinkReport ist, sonst false
 */
function CommentLink($id,$option,$badLinkReport) {
	global $database, $Itemid, $my, $option, $ld, $temp;

	$row = new snrLinks($database);
	$row->load($id);

	if (empty($row) || $row->published != 1) {
		mosNotAuth();
		return;
	} else {
		$rev_text = trim( mosGetParam( $_POST, 'rev_text', '' ) );
		$rev_title = trim( mosGetParam( $_POST, 'rev_title', '' ) );
		$guest_name = trim( mosGetParam( $_POST, 'guest_name', '' ) );
		$report_type_list = NULL;
		if (!$badLinkReport){
			if (!comment_allow($row)){
				return;
			}
		} else {
			$report_type = intval( mosGetParam( $_POST, 'report_type', 1 ) );
			$report_type_list = ComponetBadLinks('report_type', $report_type);
		}
			
		$detailurl  = getItemURL('detail',$row->id,$Itemid);
		$rateurl    = getItemURL('rate',$row->id,$Itemid);
		$commenturl = getItemURL('comment',$row->id,$Itemid);
		$reporturl  = getItemURL('report',$row->id,$Itemid);
		$row->url = getUrlToLink($row->url,$row->id,$Itemid);

		$temp->id     = $id;
		$temp->row    = $row;
		$temp->catid  = $row->catid;
		$temp->Itemid = $Itemid;
		$temp->option = $option;
		$temp->myid   = $my->id;

		$temp->ratelink             = $ld->ratelink;
		$temp->commentlink          = $ld->commentlink;
		$temp->badlink              = $ld->badlink;
		$temp->showfastlink         = $ld->showfastlink;
		$temp->javascriptchecks     = $ld->javascriptchecks;
		$temp->ldshowlinkadd        = $ld->ldshowlinkadd;
		$temp->showhits             = $ld->showhits;
		$temp->copyrigthinfo        = $ld->copyrigthinfo;
		$temp->version              = $ld->version;
		$temp->showlongdescription  = $ld->ldlongdetail;

		$temp->detailurl  = $detailurl;
		$temp->rateurl    = $rateurl;
		$temp->commenturl = $commenturl;
		$temp->reporturl  = $reporturl;
		$temp->report_type_list = $report_type_list;

		$temp->rev_text   = $rev_text;
		$temp->rev_title  = $rev_title;
		$temp->guest_name = $guest_name;
			
		$temp->display('header.tpl.php');
		$temp->display('linkdetail.tpl.php');
		$temp->display('addcomment.tpl.php');
		$temp->display('footer.tpl.php');
	}
}

/**
 * Fügt einen Kommentar in die Datenbank ein. Prüft ggf, ob das richtige Captcha eingegeben worden ist
 * und ob alle Pflichtfelder ausgefüllt worden sind.
 *
 * @param int $id Id des Links, der kommentiert werden soll
 * @param String $option unbenutzt
 * @param boolean $badLinkReport true, wenn ein Bad Link Report geschrieben werden soll, sonst false
 */
function AddComment($id,$option,$badLinkReport) {
	global $database, $Itemid, $my, $ld;

	$checkSecurity = validateCaptcha();
	if (!$checkSecurity) {
		displayError(_LD_LINK_REFUSED);
		CommentLink($id,$option,$badLinkReport);
		return;
	}

	$guest_name = trim( mosGetParam( $_POST, 'guest_name', '' ) );
	$rev_text = trim( mosGetParam( $_POST, 'rev_text', '' ) );

	if ($badLinkReport){
		$report_type = trim( mosGetParam( $_POST, 'report_type', '' ) );
		switch ($report_type){
			case 1:
				$rev_title=_LD_R1;
				break;
			case 2:
				$rev_title=_LD_R2;
				break;
			case 3:
				$rev_title=_LD_R3;
				break;
			case 4:
				$rev_title=_LD_R4;
				break;
			case 0:
			default:
				$rev_title='';
				break;;
		}
	} else {
		$rev_title = trim( mosGetParam( $_POST, 'rev_title', '' ) );
		$report_type=0;
	}

	$link = new snrLinks($database);
	$link->load($id);

	if (empty($link) || $link->published != 1) {
		# Link is not valid
		mosNotAuth();
		return;
	}

	if ( $rev_text == '' ) {
		# Comment text is empty
		displayError(_LD_WRITE_YOUR_COMMENT);
		CommentLink($id,$option,$badLinkReport);
		return;
	}
	if ( $rev_title == '' ) {
		# Comment title is empty
		displayError(_LD_WRITE_YOUR_TITLE);
		CommentLink($id,$option,$badLinkReport);
		return;
	}
	
	if ($badLinkReport){
		if (!insertNewComment($id, $my->id, $guest_name, $report_type, $rev_title, $rev_text, 0)) {
			mosRedirect(getItemURL('detail',$id,$Itemid),_LD_UNEXPECTED_ERROR);
			return;
		}

		# Send Email
		sendEmail($id, $guest_name, $rev_title, $rev_text,$Itemid);

		mosRedirect(getItemURL('detail',$id,$Itemid), _LD_REPORT_SENDED );
		return;
	} else {
		if ( $ld->gaddcom == '0' && $my->id  < 1) {
			# User is not logged in
			mosRedirect(getItemURL('detail',$id,$Itemid), _LD_LOGIN_FIRST );
			return;
		}

		# User IP Address
		$vote_ip = getenv( 'REMOTE_ADDR' );

		# Check if this user has comment before
		if ( $my->id == 0 ) {
			$database->setQuery( "SELECT log_date FROM #__ldlog WHERE link_id ='".$id."' AND log_ip = '".$vote_ip."' AND log_type = 'comment'" );
		} else {
			$database->setQuery( "SELECT log_date FROM #__ldlog WHERE link_id ='".$id."' AND user_id = '".$my->id."' AND log_type = 'comment'" );
		}

		$soner = $database->loadResult();

		$comment = false;
		$comment = ($soner <> '') ? false : true;

		if ( $comment  && $ld->writeonce == '1' || $ld->writeonce == '0'  ) {

			# Everything is ok, add the comment
			if ($comment) {
				# Update #__ld_log table
				$database->setQuery( "INSERT INTO #__ldlog "
				.	"( `log_ip` , `log_type`, `user_id` , `log_date` , `link_id` )"
				.	"VALUES ( '$vote_ip', 'comment', '$my->id', '$now', '$id')");
				if (!$database->query()) {
					mosRedirect(getItemURL('detail',$id,$Itemid),_LD_UNEXPECTED_ERROR);
				}
			}

			# Auto Publish?
			if ( $ld->autopbcomment == 1 ) {
				$rev_approved = 1;
				$succsess_msg = _LD_YOUR_COMMENT;
			} else {
				$rev_approved = 0;
				$succsess_msg = _LD_YOUR_COMMENT_WAIT;
			}

			if (!insertNewComment($id, $my->id, $guest_name, $report_type, $rev_title, $rev_text, $rev_approved)) {
				mosRedirect(getItemURL('detail',$id,$Itemid),_LD_UNEXPECTED_ERROR);
				return;
			}

			
			mosRedirect(getItemURL('detail',$id,$Itemid), $succsess_msg);
			return;
		}
		mosRedirect(getItemURL('detail',$id,$Itemid), _LD_ONLY_ONCE_C );
	}
}

/**
 * Liefert die Anzahl Kommentare es veröffentlichen Links
 *
 * @param id $linkid Id des veröffentlichen Links 
 * @return int Anzahl der Kommentare eines Links
 */
function countCommentsForLink($linkid){
	global $database;

	//Get total comments
	$query = "SELECT COUNT( rev_id )"
	. "\n FROM #__ldcomment"
	. "\n WHERE link_id = ". $linkid
	. "\n AND rev_approved = 1"
	;

	$database->setQuery( $query );
	$amountComments = $database->loadResult();
	return $amountComments;
}

/**
 * Anzeige der veröffentlichen Kommentare eines veröffentlichen Links
 *
 * @param int $id Id des Links, dessen Kommentare angezeigt werden soll
 * @param int $limitstart Start-Kommentar
 */
function LDReview(&$id, $limitstart) {
	global $database, $Itemid, $ld, $temp;

	$query = "SELECT COUNT(*) FROM #__ldcomment"
	. "\n WHERE rev_approved = 1 AND link_id = $id"
	;

	$database->setQuery($query);
	$totalcomments = $database->loadResult();
	if (($totalcomments > $ld->limitcomment) && ($ld->limitcomment > 0)) {
		require_once( _LD_ABSOLUTE_PATH . '/includes/pageNavigation.php' );
		$pageNav = new mosPageNav( $totalcomments, $limitstart, $ld->limitcomment );
	}
	else {
		$pageNav = NULL;
	}
	$query = "SELECT * FROM #__ldcomment"
	. "\n WHERE link_id = $id"
	. "\n AND rev_approved = 1"
	. "\n LIMIT $limitstart, $ld->limitcomment"
	;

	$database->setQuery( $query );
	$comments = $database->loadObjectList();

	$temp->id = $id;
	$temp->limitstart = $limitstart;
	$temp->comments = $comments;
	//$temp->option = $option;
	$temp->integration = $ld->integration;
	$temp->pageNav = $pageNav;
	$temp->display('commentlist.tpl.php');

}
?>
